Files upload Restriction by files extensions

2015-06-03 16:07 - Varadharajan Sundaram

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: Attachments Estimated time: 0.00 hour

Target version: 3.2.0   

Resolution: Fixed   

Description

Hi,

We are using redmine 2.5.1 with below settings in Ubuntu 14.04 LTS

Environment:

Redmine version                2.5.1.stable

Ruby version                   2.0.0-p645 (2015-04-13) [x86_64-linux-gnu]

Rails version                  3.2.17

Environment                    production

Database adapter               MySQL

SCM:

Subversion                     1.8.8

Git                            1.9.1

Filesystem

Redmine plugins:

AgileDwarf                     0.0.3

progressive_projects_list      1.0.0

redmine_cas                    1.2.1

redmine_issue_templates        0.1.0

redmine_ldap_sync              2.0.4.g0693d11a0c

Everything is working fine but our security team is rejected to expose outside (internet) becasue of there is no option for Files

extensions upload restrictions.That mean, we need to allow only certain files but right now redmine is accepting all the files

extensions (.exe,zip,msi,....etc). I searched in entire issues and google but no luck. Please let me know, what is the solution for this

and treated this as a bug.

Associated revisions

Revision 14792 - 2015-11-01 11:41 - Jean-Philippe Lang

Files upload restriction by files extensions (#20008).

Revision 14793 - 2015-11-01 11:41 - Jean-Philippe Lang

Adds strings to locales (#20008).

History

#1 - 2015-06-03 16:16 - Toshi MARUYAMA

- Tracker changed from Defect to Feature

- Category changed from Files to Attachments

- Priority changed from High to Normal

#2 - 2015-06-03 16:17 - Toshi MARUYAMA

- Subject changed from Files upload Restriction is not available to Files upload Restriction by files extensions

#3 - 2015-06-08 11:51 - Varadharajan Sundaram

Please let me know, can i try any alternative method to fix this issue ?

#4 - 2015-06-09 14:56 - madhusudan kh
- File attachment.rb.patch added

- File en.yml.patch added

Hi,

I got it working by weired hack!, I was facing the same issue, our security team wont allow site to be exposed outside until basic security

vulnerabilities are fixed, I tried with apache by doing Filesmatch but that didn't work, so came up with this solution.

Ideally this is one of the basic need for all web applications!, don't know why this was ignored!, anyways here it is.

u need to change 2 files (in my system redmine is installed in /usr/share/)

main file to allow valid file types

/usr/share/redmine/app/models/attachment.rb

language wise error notification output file

/usr/share/redmine/config/locales/en.yml

check the patch Files attached for patching the above two files, and make sure u take these two files backup before patching.

how to patch:

just cd  to that respective directory and enter below command

patch -p0 <  attachment.rb.patch

patch -p0 <  en.yml.patch

(note: only files with below file types are allowed)

('.txt','.csv','.htm','.html','.xml','.css','.doc','.docx','.xls','.xlsx','.rtf','.ppt','.pptx','.pdf','.swf','.flv','.avi','.wmv','.mov','.jpg','.jpeg','.gif','.png')

if you want to add or delete extensions for  allowed file types u can modify  file  /usr/share/redmine/app/models/attachment.rb

just go through u will get it..

Hope it will be useful for someone who are in really need, also hope to see this feature in next version?.:-)

#5 - 2015-10-06 11:52 - Jonathan Tee

- File redmine-WhitelistAndBlacklist-attachment-extensions.diff added

- File screenshot.png added

Hi,

we made a new version of this patch, which should be easier to integrate into core. When patch is installed, it will make nothing. But under Settings

you are able to define your own white/blacklist for file extensions.

the following checks are made if you try to upload new files:

empty whitelist, empyt blacklist: everything is allowed

empty whitelist, defined blacklist: only not blacklisted extensions are allowed

defined whitelist, empty blacklist: only whitelisted extensions are allowed

if a extension is blacklisted, whitelist will not be checked anymore for this extension

Patch made for Redmine3.1

#6 - 2015-10-06 18:25 - Jean-Philippe Lang

- Assignee set to Jean-Philippe Lang

- Target version set to 3.2.0

#7 - 2015-11-01 11:41 - Jean-Philippe Lang

- Status changed from New to Closed

- Resolution set to Fixed

Feature added in r14792.

Files

attachment.rb.patch 1.21 KB 2015-06-09 madhusudan kh
https://www.redmine.org/projects/redmine/repository/svn/revisions/14792


en.yml.patch 742 Bytes 2015-06-09 madhusudan kh

redmine-WhitelistAndBlacklist-attachment-extensions.diff 4.08 KB 2015-10-06 Jonathan Tee

screenshot.png 59.3 KB 2015-10-06 Jonathan Tee
